// -*- mode: c++; c-indent-level: 4; c++-member-init-indent: 8; comment-column: 35; -*-
//		    EZSAMPLE.HPP
//  Easy class that loads a file and places it in a matrix. Operators duly
//  overloaded. The template class can be any scalar; or a class with >> 
//  overloaded, and with a void constructor.


#ifndef _EZSAMPLE_HPP
#define _EZSAMPLE_HPP

#include <fstream.h>
#include <string.h>

#include "weight.hpp"		   // for the Weight template

template <class vecType>
class ezSample {

  public:

    ezSample( const char * _fName, unsigned _vecSize );
    ~ezSample();
    
    const vecType * operator [] ( unsigned _idx ) const {
      return ( _idx<size) ? inSample[_idx]: 0;
    }

    // conversion operator
    Weight<vecType> getVect ( unsigned _idx ) const; 
				   // Cannot overload by return type

    // info operators
    unsigned getSize ( void ) const { return size;};
    
  private:
    vecType ** inSample;
    unsigned size;		   // file & array size
    unsigned vecSize;		   // vector Size
    
};

#include "ezsample.icc"		   // template definition


#endif				   // _EZSAMPLE_HPP
